#include "xbasic_types.h"
#include "xio.h"

#include "xintc_l.h"
#include "xuartlite_l.h"
#include "xparameters.h"
#include "terminal.h"
/* Defined in mymicroblaze/xparameters.h */
/* #define XPAR_VGA_BASEADDR 0xFEFF1000 */
/* #define XPAR_VGA_HIGHADDR 0xFEFF1fff */

#define FONT_OFFSET 0xA00

/* Address of a particular character on the screen (rows are 80) */
#define CHAR(r,c) \
   (((unsigned char *)(XPAR_VGA_BASEADDR))[(c) + ((r) << 6) + ((r) << 4)])

/* Start of font memory */
#define FONT ((unsigned char *)XPAR_VGA_BASEADDR + FONT_OFFSET)

//*** these all moved to terminal.h
// * buf variables booted because we do not use buff
// * same for lp, fp
static int col = -1;
static int row = 0;
 
/* Write a text string on the display */
void put_string(char string)
{
  
  //these move the cursor
  if(string == 0x0d) //if control-m (carriage return)
    {
      string = 0x20; //use blank
      col = -1;
    }

  if(string==0x0a) //if control-j (line feed)
    {
      string = 0x20; //use blank
      row++;
      col--;
    }

  //*****************************************
  // This part write the character to video
  //
  //*****************************************
  
  //get the screen position and write the character to it
  //print("setting cursor\r\n");
  char *cursor = &(CHAR(row, col));
  *cursor = string;
  //print("wrote string: ");
  //print(&string);
  //print("\r\n");
}


void init_video(){ 
  volatile unsigned char *p;
  print("initing video\r\n");
  for ( p = &(CHAR(0,0)) ; p < &(CHAR(29,80)) ; ++p)
    *p = ' ';
}


char_to_video(char c)
{
  //  volatile unsigned char *p;
  unsigned char v, vv;
  int i, j, k;
  int cnt;
  /* Clear the screen */

  //  print("received character ");
  print(&c);
  //print("\r\n");

  if (col>=79) // narrowing to the 80 columns of the Display
    {
      col = 0;
      row++;
    } 
  else
    col++;

  if(row >= 30)
    {
      for(i=0;i<30;i++)       //row
	{
	  for(j=0;j<80;j++)   //column
	    CHAR(i,j)=CHAR(i+1,j);
	}
      
      row = 29;
    }

  //This actually puts the character on the screen
  put_string(c);


  if (col>77)
    {
      col=1;
      row++;
    }
  //else
  //col++;
}
