library ieee;
use ieee.std_logic_1164.all;

entity tb is
  
end tb;

architecture tb of tb is

signal OPB_Clk     :  std_logic;
signal  OPB_Rst     :  std_logic;
signal       OPB_ABus    :  std_logic_vector(0 to 31);
signal    OPB_BE      :   std_logic_vector(0 to 3);  -- not usg this
signal    OPB_DBus    :   std_logic_vector(0 to 31);
signal    OPB_RNW     :   std_logic;
signal    OPB_select  :   std_logic;
signal    OPB_seqAddr :   std_logic;        -- Sequential Address
signal    Sln_DBus    :  std_logic_vector(0 to 31);
signal    Sln_errAck  :  std_logic;        -- (unused)
signal    Sln_retry   :  std_logic;        -- (unused)
signal    Sln_toutSup : std_logic;        -- Timeout suppress
signal    Sln_xferAck : std_logic;       -- Transfer acknowledge

       --ports between peripheral and Ethernet
signal    ETH_CS       :  std_logic;
signal    ETH_IOCS     :   std_logic;
signal    ETH_RDY_DTAK :   std_logic;
signal    ETH_IREQ     :   std_logic;
    
 --    ETH_data     : out std_logic_vector(15 downto 0)

     --ports between peripheral and SRAM
     -- IOR IOW AEN_PSEN BHE address and data
signal    RAM_CE          :  std_logic;
signal    PB_OE_IOR          :  std_logic;
signal    PB_WE_IOW          :  std_logic;
signal    PB_UB_BHE          :  std_logic;
signal    PB_LB_AEN          :  std_logic;
signal    PB_D   :  std_logic_vector(0 to 15);
signal    PB_A   :  std_logic_vector(0 to 17);
  
begin

ut: entity work.sram_ethernet port map (
    OPB_Clk =>     OPB_Clk,
    OPB_Rst =>     OPB_Rst,
    OPB_ABus =>     OPB_ABus,
    OPB_BE =>     OPB_BE,
    OPB_DBus =>     OPB_DBus,
    OPB_RNW =>     OPB_RNW,
    OPB_select =>     OPB_select,
    OPB_seqAddr =>     OPB_seqAddr,
    Sln_DBus =>     Sln_DBus,
    Sln_errAck =>     Sln_errAck,
    Sln_retry =>     Sln_retry,
    Sln_toutSup =>     Sln_toutSup,
    Sln_xferAck =>     Sln_xferAck,

       --ports between peripheral and Ethernet
    ETH_CS =>     ETH_CS,
    ETH_IOCS =>     ETH_IOCS,
    ETH_RDY_DTAK =>     ETH_RDY_DTAK,
    ETH_IREQ =>     ETH_IREQ,
    
    RAM_CE =>     RAM_CE,
    PB_OE_IOR =>     PB_OE_IOR,
    PB_WE_IOW =>     PB_WE_IOW,
    PB_UB_BHE =>     PB_UB_BHE,
    PB_LB_AEN =>     PB_LB_AEN,
    PB_D =>     PB_D,
    PB_A =>     PB_A
  
);
  
process
begin
  OPB_Rst <= '1';
  wait for 30 ns;
  OPB_Rst <= '0';
  wait;
end process;

process
begin
  OPB_Clk <= '1';
  wait for 10 ns;
  OPB_Clk <= '0';
  wait for 10 ns;
end process;
  
process
begin  
  OPB_Select <= '0';
  wait for 100 ns;

  -- wr 32
  
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_0000";
  OPB_BE <= "1111";
  OPB_DBus <= X"1234ABCD";
  OPB_RNW <= '0';
              
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_0000";
  OPB_BE <= "1111";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
  
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  -- wr16
  

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_0000";
  OPB_BE <= "1100";
  OPB_DBus <= X"12341234";
  OPB_RNW <= '0';
              
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';


  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_0002";
  OPB_BE <= "0011";
  OPB_DBus <= X"12341234";
  OPB_RNW <= '0';
              
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';


--   -- wr8

wait until OPB_Clk'event and OPB_Clk='1';
 wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '1';
  OPB_ABus <= X"0000_0000";
   OPB_BE <= "1000";
   OPB_DBus <= X"CDCDCDCD";
   OPB_RNW <= '0';
              
   wait until Sln_xferack = '1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '0';
  
  wait until OPB_Clk'event and OPB_Clk='1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '1';
   OPB_ABus <= X"0000_0001";
   OPB_BE <= "0100";
   OPB_DBus <= X"EFEFEFEF";
   OPB_RNW <= '0';
              
   wait until Sln_xferack = '1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '0';
  
  wait until OPB_Clk'event and OPB_Clk='1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '1';
   OPB_ABus <= X"0000_0002";
   OPB_BE <= "0010";
   OPB_DBus <= X"ABABABAB";
   OPB_RNW <= '0';
              
   wait until Sln_xferack = '1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '0';
  
  wait until OPB_Clk'event and OPB_Clk='1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '1';
   OPB_ABus <= X"0000_0003";
   OPB_BE <= "0001";
   OPB_DBus <= X"34343434";
   OPB_RNW <= '0';
              
   wait until Sln_xferack = '1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '0';

 -- Ethernet write 16 bit
  
     wait until OPB_Clk'event and OPB_Clk='1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '1';
   OPB_ABus <= X"0008_0000";
   OPB_BE <= "1100";
   OPB_DBus <= X"1A2A1A2A";
   OPB_RNW <= '0';
              
   wait until Sln_xferack = '1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '0';


   wait until OPB_Clk'event and OPB_Clk='1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '1';
   OPB_ABus <= X"0009_0002";
   OPB_BE <= "0011";
   OPB_DBus <= X"A1A1A1A1";
   OPB_RNW <= '0';
              
   wait until Sln_xferack = '1';
   wait until OPB_Clk'event and OPB_Clk='1';
   OPB_Select <= '0';


-----------------------------read ---------------------------------------
  
  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_0000";
  OPB_BE <= "1111";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
  
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

   
  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_0000";
  OPB_BE <= "0001";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';

  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_2220";
  OPB_BE <= "0010";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
    
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_3330";
  OPB_BE <= "0100";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
    
  
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0000_4440";
  OPB_BE <= "1000";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
    
  
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0008_2220";
  OPB_BE <= "0011";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
    
  
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait until OPB_Clk'event and OPB_Clk='1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '1';
  OPB_ABus <= X"0009_4440";
  OPB_BE <= "1100";
  OPB_DBus <= X"11111111";
  OPB_RNW <= '1';
    
  
  wait until Sln_xferack = '1';
  wait until OPB_Clk'event and OPB_Clk='1';
  OPB_Select <= '0';

  wait;

end process;  
  

pb_d <= X"E" & pb_a(6 to 17) when pb_oe_ior = '0' and eth_cs = '0' else
        X"5" & pb_a(6 to 17) when pb_oe_ior = '0' and ram_ce = '0' else
        (others => 'Z');


end tb;
